
class AlgoParamHelper{
  final String para;
  static const ff="facetFilters";
  static const of="optionalFilters";
  static const nf="numericFilters";
  static const tf="tagFilters";
  static const fs=[ff,of,nf,tf];
  AlgoParamHelper(this.para);

  Map<String,String> get param=>Uri.splitQueryString(Uri.decodeQueryComponent(para));
  List<String> get filters{
    final fm=param..removeWhere((k, v) => !fs.contains(k));
    final fl=<String>[];
    fm.forEach((k, v) {
      if(v!="[]"){
        final l=v.substring(1,v.length-1).split(",");
        fl.addAll(l.map((e) => e.replaceAll("\"","").replaceAll("[","").replaceAll("]","")));
      }
    });
    return fl.toSet().toList();
  }

  List<String> excludeFilters(List<String> excludes){
    return filters.where((e) => excludes.every((pf) => !e.startsWith(pf))).toList();
  }
}