import 'package:algolia/algolia.dart';

import '../model/search_data/search_data.dart';

abstract class baseTRepo<T>{
  Future<searchData<T>>searchT_algo(String? qr,
      {List<String> attributes=const ["objectId"],
        List<AlgoliaQuery Function(AlgoliaQuery)>?filters ,List<String>? strFilters,
        int page=0,int hperp=10,String? containID});

  Future<T> getbyId(String id);
  Future<T> read(T c,String uid);
  Future<T> add(T c);
  Future<void> edit(T c);
  Future<void> deletebyId(String id);
}